<?php

/**
 * SPDX-License-Identifier: MIT
 * Find the full license text at: https://gitlab.com/1of0/php/iptmerge/-/blob/master/LICENSE.md
 */

namespace OneOfZero\IptMerge\Command;

use OneOfZero\IptMerge\Merge\Configuration\MergeBehaviour;
use OneOfZero\IptMerge\Merge\StateMerger;
use OneOfZero\IptMerge\Netfilter\Netfilter;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\StreamableInputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Yaml\Yaml;

class Generate extends Command
{
    protected function configure(): void
    {
        $this
            ->setName('merge')
            ->setDescription(
                'Merges two iptables-save formatted dumps, and outputs a dump that can be restored with ' .
                '`iptables-restore --noflush`'
            )
            ->addArgument(
                'merge-behaviour-file',
                InputArgument::REQUIRED,
                'File containing a YAML document with settings for the generator.'
            )
            ->addArgument(
                'generated-state-file',
                InputArgument::REQUIRED,
                'File containing an iptables-save formatted configuration that will be used as master template for ' .
                'the restore file.'
            )
            ->addArgument(
                'running-state-file',
                InputArgument::OPTIONAL,
                'File containing an the running iptables configuration as generated by iptables-save. If not ' .
                'provided the running state should be provided through STDIN.'
            );
    }

    protected function execute(InputInterface $input, OutputInterface $output): int
    {
        $mergeSettings      = Yaml::parseFile($input->getArgument('merge-behaviour-file'));
        $generatedStateFile = $input->getArgument('generated-state-file');
        $runningStateFile   = $input->getArgument('running-state-file');

        $netfilter = new Netfilter();

        $generatedState = $netfilter->parseStateFromFile($generatedStateFile);

        if (!$runningStateFile && $input instanceof StreamableInputInterface) {
            $runningState = $netfilter->parseStateFromString(stream_get_contents($input->getStream()));
        } else {
            $runningState = $netfilter->parseStateFromFile($runningStateFile);
        }

        $stateMerger = new StateMerger(MergeBehaviour::fromArray($mergeSettings));
        $output->write($stateMerger->merge($runningState, $generatedState));

        return 0;
    }
}
